/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        27.09.2007
 Description:    RGB-LED Farbenspiel
----------------------------------------------------------------------------*/

#include <avr/interrupt.h>
#include <avr/io.h>

#define	LED_R	(1<<3)
#define LED_G	(1<<1)
#define LED_B	(1<<2)

#if defined (__AVR_ATtiny45__)
	#define TIMER0_OVF0_vect TIMER0_OVF_vect
	#define TCCR0 TCCR0B
#endif


volatile char pwm_counter,pwm_r,pwm_g,pwm_b;

//----------------------------------------------------------------------------
ISR (TIMER0_OVF0_vect)
{
	if (pwm_counter++ > 63) 
	{
		PORTB = 0x00;
		pwm_counter = 0;
	}
	if (pwm_counter > pwm_r) PORTB |= LED_R;
	if (pwm_counter > pwm_g) PORTB |= LED_G;
	if (pwm_counter > pwm_b) PORTB |= LED_B;	
}

//----------------------------------------------------------------------------
//Hauptprogramm
int main (void) 
{
	//Port fr LED auf output
	DDRB = LED_R|LED_G|LED_B;
	
	//Interrupt for the Clock enable  
    TIMSK |= (1 << TOIE0);
	//Setzen des Prescaler auf 1024 
	TCCR0 |= (1<<CS00 | 0<<CS01 | 0<<CS02); 
	//TCNT0 = 65535 - (OSC_CLK / 1024);	
	
	sei();
	
	pwm_r = 0;
	pwm_g = 64;
	pwm_b = 64;
		
	while(1)
	{ 	
		for (char a = 0; a<65; a++)
		{
			pwm_r = a;
			pwm_b = 64 - a;
			for (long b = 0;b<10000;b++){asm("nop");};
		}

		for (char a = 0; a<65; a++)
		{
			pwm_b = a;
			pwm_g = 64 - a;
			for (long b = 0;b<10000;b++){asm("nop");};
		}
		
		for (char a = 0; a<65; a++)
		{
			pwm_g = a;
			pwm_r = 64 - a;
			for (long b = 0;b<10000;b++){asm("nop");};
		}

	}
}

